<?php
/**
 * @copyright ICZ Corporation (http://www.icz.co.jp/)
 * @license See the LICENCE file
 * @author <sencha@icz.co.jp>
 * @version $Id$
 */

class AppController extends Controller {

	public $autoLayout = false;

	var $helpers = array('Session','Form','Html','Js'=>array('jquery'),'CustomHtml','CustomAjax','CustomJs', 'time');

	var $uses = array('Request','Message','Notice','Configration','User');
	var $components = array('Session','Auth','Cookie', 'Common');
	function beforeFilter(){
		//プロキシサーバー経由でアクセスした際のcacheを行わない処理を追加
		$this->header('Expires: Sat, 26 Jul 1997 05:00:00 GMT');
		$this->header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');
		$this->header('Pragma: no-cache');

		$this->Auth->allow(array('controller' => 'storages', 'action' => 'thumbnail'));
		$this->User_Check();
		$this->set("user",$this->Auth->user());
		$this->set("request",$this->Request->Get_Request($this->Auth->user()));
		$this->set("message",$this->Message->Get_Message($this->Auth->user(),null,true));
		$this->set("notice",$this->Notice->Get_Notice($this->Auth->user()));
		$this->set('invite_conf',$this->Configration->find('first',array('conditions'=>array('NAME'=>'INVIETE'))));
	}

	function Authority_Check(){
		$user = $this->Auth->user();
		if($user['User']['AUTHORITY']==0){
			return true;
		}else{
			return false;
		}
	}
	function month_days($m,$y)
	{
		if($m==4||$m==6||$m==9||$m==11)
		return 30;
		if($m!=2) return 31;
		if($y%400==0) return 29;
		if($y%100==0) return 28;
		if($y%4==0) return 29;
		return 28;
	}
	function User_Check(){
		$user = $this->Auth->user();
		if($user!=null){
			$user_n = $this->User->find('first',array('fields'=>array('User.DEL_FLG','User.STATUS'),'conditions'=>array('User.USR_ID'=>$user['User']['USR_ID'])));
			if($user_n['User']['STATUS']!=1){
				$this->Session->setFlash('ユーザが使用不可能になっています。','');
				$this->redirect(array('controller'=>'users','action'=>'logout'));
			}
		}
	}

	//CSRF対策、トークンチェック
	function isCorrectToken($_token) {
		if($_token === session_id()) {
			return true;
		}else {
			$this->data = null;
			$this->Session->setFlash('正規の画面からご利用ください。','');
			$this->redirect(array('controller'=>'users','action'=>'logout'));
			return false;
		}
	}

}