<?php
/**
* @copyright ICZ Corporation (http://www.icz.co.jp/)
* @license See the LICENCE file
* @author <sencha@icz.co.jp>
* @version $Id$
*/

/**
 * 管理者用のcontrollerクラス
 */

class AdministratorsController extends AppController {

	var $name = "Administrator";
	var $uses = array("Administrator","User",'Message','Timeline','Join','Friend','Group','Notice','Watch','Read','Storage');
	var $autoLayout = true;
	var $components = array('Session','Auth','Cookie');

	public $paginate = array(
			'page'=>1,
			'conditions'=>array(),
			'sort'=>'',
			'limit'=>10,
			'order'=>'Administrator.USR_ID',
			'recursive'=>0
	);

	function beforeFilter(){
		parent::beforeFilter();
		if(!$this->Authority_Check()){
			$this->Session->setFlash('管理者以外アクセスできません');
			$this->redirect("/homes");
		}
	}

	//ユーザ一覧
	function index(){
		//初期化
		$this->set("main_title", "管理者メニュー");
		$this->set("title_text","ユーザ管理");
		$user = $this->Auth->user();

		$list = $this->paginate(array('DEL_FLG'=>0));

		//変数セット
		$this->set("user_status",Configure::read('UserSTATUS'));
		$this->set("index_list",$list);
	}

	//ユーザ追加
	function add(){
		//初期化
		$this->set("main_title", "管理者メニュー");
		$this->set("title_text","ユーザ追加");

		if(isset($this->params['form']['can_y'])){
			$this->redirect("/administrators/");
		}

		if(isset($this->data) && $this->data && $this->isCorrectToken($this->data['Security']['token'])){
			//サブミットが押された場合
			//バリデーション（パスワードのチェック）
			$this->Administrator->set($this->data['Administrator']);
			$error = $this->Administrator->invalidFields(array('fieldList'=>'EDIT_PASSWORD'));
			if(!isset($error['EDIT_PASSWORD'])){
				$this->data['Administrator']['PASSWORD'] = $this->Auth->password($this->data['Administrator']['EDIT_PASSWORD']);
			}
			//データベース上に同じメールアドレスがあるかどうかのチェック
			$mail = $this->Administrator->Mail_Search($this->data['Administrator']['MAIL']);
			//データのセーブ
			$id = $this->Administrator->User_Save($this->data,null,$mail);
			if($id != false){
				//成功
				$this->Session->setFlash('ユーザを保存しました');
				$this->redirect("/administrators/");
			}
			else{
				//失敗
				if(!$mail){
					//メールアドレスが被っていた場合のバリデーションエラー
					$this->Administrator->validationErrors["MAIL"]="そのメールアドレスは使用できません。";
				}
				$this->Session->setFlash('ユーザ保存に失敗しました。');
			}
		}
	}
	//ユーザ編集
	function edit(){
		//初期化
		$this->set("main_title", "管理者メニュー");
		$this->set("title_text","ユーザ編集");

		if(isset($this->params['form']['can_y'])){
			$this->redirect("/administrators/");
		}
		if(isset($this->data) && $this->isCorrectToken($this->data['Security']['token'])){
			//サブミットが押された場合の表示
			//パスワードのバリデーションチェック
			if($this->data['Administrator']['PASS_C']==1){
				$error = $this->Administrator->invalidFields(array('fieldList'=>'EDIT_PASSWORD'));
				if(!isset($error['EDIT_PASSWORD'])){
					$this->data['Administrator']['PASSWORD'] = $this->Auth->password($this->data['Administrator']['EDIT_PASSWORD']);
				}
			}else{
				unset($this->data['Administrator']['PASSWORD']);
				unset($this->data['Administrator']['EDIT_PASSWORD']);
			}
			//かぶっているメールアドレスがあるかのチェック（自分のIDと同じものでない場合エラー）
			$mail = $this->Administrator->Mail_Search($this->data['Administrator']['MAIL'],$this->data['Administrator']['USR_ID']);
			//ユーザの保存
			$id = $this->Administrator->User_Edit($this->data);
			if($id != false){
				//成功
				$this->Session->setFlash('ユーザを変更しました');
				$this->redirect("/administrators/");
			}
			else{
				//失敗
				if(!$mail){
					//同じメールアドレスがあった場合の処理
					$this->Administrator->validationErrors["MAIL"]="そのメールアドレスは使用できません。";
				}
				$this->set('pass_c',$this->data['Administrator']['PASS_C']);
				$this->Session->setFlash('ユーザに変更に失敗しました。');
			}
		}else{
			//初期表示
			//パスからIDを取り出す
			$id = $this->params['pass'][0];
			//データベースからユーザ情報を取り出しセット
			$this->data = $this->Administrator->find('first',array('conditions'=>array('Administrator.USR_ID'=>$id)));
			$this->data['Administrator']['USR_ID']=$id;
			$this->set('pass_c',0);
		}
	}

	//ユーザ使用不可能の処理
	function valid(){
		//初期化
		$this->autoRender = false;
		$this->uses = null;
		configure::write('debug',0);
		$user = $this->Auth->user();

		//トークンチェック
		$this->isCorrectToken($this->params['form']['token']);

		//パスから現在のステータスを取り出す
		$id = $this->params['pass'][0];

		//一つ目のパスにIDが入っていた場合
		//変更処理
// 		$this->Administrator->Change_STAT($id);

		$w=array('Watch.USR_ID'=>$id);
		$this->Watch->create();
		$this->Watch->deleteAll($w,false,false);

		$this->Read->Read_Delete($id);
		$r=array('Read.USR_ID'=>$id);
		$this->Read->create();
		$this->Read->deleteAll($r,false,false);

		$this->Request->Delete_Request($id,null);

		//メッセージ削除
		$this->Message->Dlete_All($id);
		//グループ参加情報を全て削除
		$this->Join->Dlete_All($id);
		//友人関係を全て削除
		$this->Friend->Dlete_All($id);
		//ユーザグループ削除
		$this->Group->delete_my_group($id);
		$this->Notice->Delete_Notice($id);
		$this->Timeline->Dlete_All($id,false,false);
		$this->Administrator->Delete_User($id);

		$list = $this->Administrator->find('first',array('conditions'=>array('Administrator.USR_ID'=>$id)));
		$this->set("list",$list);
		$this->render('valid',false);
	}
	function delete(){
		//初期化
		$this->set("main_title", "管理者メニュー");
		$this->set("title_text","ユーザ削除");

		$user = $this->Auth->user();
		$id= $this->params['pass'][0];

		if(isset($this->data['Administrator']) && $this->isCorrectToken($this->data['Security']['token'])){
			//タイムライン削除
			if($this->data['Administrator']['COMMENT']==1){
				$this->Timeline->Dlete_All($id);
			}else{
				$this->Timeline->Dlete_All($id,false);
			}
			if($this->data['Administrator']['FILE']==1){
				//ファイル削除（空に）
				$this->Administrator->Truncate_Directory($id);
				//フォルダごと削除する。
				$this->Administrator->Dlete_Directory($id);
			}else{
				$d=array();
				$d = $this->Storage->find('all',array('fields'=>array('FLE_ID'),'conditions'=>array('Storage.USR_ID'=>$id)));
				foreach($d as $key=> $val){
					$params=array();
					$params['FLE_ID']=$val['Storage']['FLE_ID'];
					$params['DEL_FLG']=1;
					$this->Storage->create();
					$this->Storage->save($params,false);
				}
			}
			//メッセージ削除
			$this->Message->Dlete_All($id);
			//グループ参加情報を全て削除
			$this->Join->Dlete_All($id);
			//友人関係を全て削除
			$this->Friend->Dlete_All($id);
			//ユーザグループ削除
			$this->Group->delete_my_group($id);
			$this->Notice->Delete_Notice($id);

			$w=array('Watch.USR_ID'=>$id);
			$this->Watch->create();
			$this->Watch->deleteAll($w,false,false);

			$this->Read->Read_Delete($id);
			$r=array('Read.USR_ID'=>$id);
			$this->Read->create();
			$this->Read->deleteAll($r,false,false);

			$this->Request->Delete_Request($id,null);

			//ユーザごと削除
			if($this->data['Administrator']['COMMENT']==1&&$this->data['Administrator']['FILE']==1&&$this->data['Administrator']['Users']==1){
				$this->Administrator->delete($id);
			}else{
				$this->Administrator->Delete_User($id);
			}
			$this->redirect(array('controller'=>'administrators','action'=>'index'));
		}

		$result = $this->Group->find('all',array('conditions'=>array('Group.USR_ID'=>$id,'NOT'=>array('Group.TYPE'=>'2'))));

		$this->set('delete_code',Configure::read('DeleteCode'));
		$this->set('index_list',$result);
		$this->set('id',$id);
	}
}