<?php
/**
* @copyright ICZ Corporation (http://www.icz.co.jp/)
* @license See the LICENCE file
* @author <sencha@icz.co.jp>
* @version $Id$
*/

/**
 *	環境設定用のcontrollerクラス
 */

class ConfigrationsController extends AppController {

	var $name = "Configration";
	var $uses = array("Configration","User");
	var $autoLayout = true;
	var $components = array('Session','Auth','Cookie');

	function beforeFilter(){
		parent::beforeFilter();
		if(!$this->Authority_Check()){
			$this->Session->setFlash('管理者以外アクセスできません');
			$this->redirect("/homes");
		}
	}

	//現在の状態画面用
	function index(){
		//初期化
		$this->set("main_title", "管理者メニュー");
		$this->set("title_text","環境設定");
		//現在の情報を取得
		//参加設定
		$invite_v = $this->Configration->find('first',array('conditions'=>array('NAME'=>'INVIETE')));
		$invite = Configure::read('INVITE');

		$apporoval_v = $this->Configration->find('first',array('conditions'=>array('NAME'=>'APPOROVAL')));
		$apporoval = Configure::read('APPOROVAL');

		$general_v = $this->Configration->find('first',array('conditions'=>array('NAME'=>'GENERAL')));
		$general = Configure::read('GENERAL');

		$withdrawal_v = $this->Configration->find('first',array('conditions'=>array('NAME'=>'WITHDRAWAL')));
		$withdrawal = Configure::read('WITHDRAWAL');

		//変数のセット
		$this->set("invite",$invite[$invite_v['Configration']['VALUE']]);
		$this->set("apporoval",$apporoval[$apporoval_v['Configration']['VALUE']]);
		$this->set("general",$general[$general_v['Configration']['VALUE']]);
		$this->set("withdrawal",$withdrawal[$withdrawal_v['Configration']['VALUE']]);

	}
	//変更
	function edit(){
		//初期化
		$this->set("main_title", "管理者メニュー");
		$this->set("title_text","環境設定変更");

		if(isset($this->parasm['form']["can_x"])){
			$this->redirect(array('controller'=>'configrations','action'=>'index'));
		}

		//サブミットが押された場合の処理
		if(isset($this->data)&&$this->data && $this->isCorrectToken($this->data['Security']['token'])){
			//データを保存
			if($this->Configration->save_conf($this->data)){
				$this->redirect("/configrations");
			}
		}
		$invite_v = $this->Configration->find('first',array('conditions'=>array('NAME'=>'INVIETE')));
		$apporoval_v = $this->Configration->find('first',array('conditions'=>array('NAME'=>'APPOROVAL')));
		$general_v = $this->Configration->find('first',array('conditions'=>array('NAME'=>'GENERAL')));
		$withdrawal_v = $this->Configration->find('first',array('conditions'=>array('NAME'=>'WITHDRAWAL')));

		$this->data['Configration']['INVITE']=$invite_v['Configration']['VALUE'];
		$this->data['Configration']['APPOROVAL']=$apporoval_v['Configration']['VALUE'];
		$this->data['Configration']['GENERAL']=$general_v['Configration']['VALUE'];
		$this->data['Configration']['WITHDRAWAL']=$withdrawal_v['Configration']['VALUE'];

		//変数のセット
		$this->set("invite",Configure::read('INVITE'));
		$this->set("apporoval",Configure::read('APPOROVAL'));
		$this->set("general",Configure::read('GENERAL'));
		$this->set("withdrawal",Configure::read('WITHDRAWAL'));
	}
}