<?php
/**
* @copyright ICZ Corporation (http://www.icz.co.jp/)
* @license See the LICENCE file
* @author <sencha@icz.co.jp>
* @version $Id$
*/

class Join extends AppModel{

	var $name	=	'Join';
	var $useTable	=	'T_JOIN';
	var $primaryKey = 'JIN_ID';


	var $belongsTo = array(
		'User' =>
			array(
				'className'		=>	'User',
				'conditions'	=>	'',
				'order'			=>	'',
				'dependent'		=>	true,
				'foreignKey'	=>	'USR_ID',
		),
		'Group' =>
			array(
				'className'		=>	'Group',
				'conditions'	=>	'',
				'order'			=>	'',
				'dependent'		=>	true,
				'foreignKey'	=>	'GRP_ID',
		)
	);

	public Function Serarch_User($_grpid,$_userid,$_status=null){

		$conditions = array('Join.GRP_ID'=>$_grpid,'Join.USR_ID'=>$_userid);


		if($_status!=null){
			$conditions = array_merge($conditions,array('or'=>array('Join.STATUS'=>$_status)));
		}

		$result = $this->find('first',array('fields'=>array('STATUS','JIN_ID'),'conditions'=>$conditions));
		return $result;
	}

	Function Join_Group($_userid){
		$result = $this->find('all',array('fields'=>array('GRP_ID'),'conditions'=>array('Join.USR_ID'=>$_userid,'Join.STATUS'=>array(2,0))));

		return $result;
	}

	Function Group_User($_grpid,$num=10){
		$result = $this->find('all',array('conditions'=>array('Join.GRP_ID'=>$_grpid,'Join.STATUS'=>array(2,0),'User.STATUS'=>1),'limit'=>$num));

		return $result;
	}

	Function Join_User($_grpid,$_userid,$option=null,$auth=false){

		$_params = array();

		$status = $this->Serarch_User($_grpid,$_userid);
		App::import('Model','Request');
		$request = new Request;
		if($status['Join']['STATUS']==3||$status==false){
			App::import('Model','Group');
			$group = new Group;

			$type = $group->find('first',array('fields'=>array('TYPE','USR_ID'),'conditions'=>array('Group.GRP_ID'=>$_grpid)));

			$_params['GRP_ID'] = $_grpid;
			$_params['USR_ID'] = $_userid;


			if($_userid==$type['Group']['USR_ID']){
				$_params['STATUS'] = 0;
			}else{
				if($type['Group']['TYPE']==1){
					if(!$auth){
						$_params['STATUS'] = 1;
					}else{
						$_params['STATUS'] = 2;
					}
				}else{
					$_params['STATUS'] = 2;
				}
			}
			$_params['INSERT_DATE'] = date("Y-m-d H:i:s");
			$_params['LAST_UPDATE'] = date("Y-m-d H:i:s");
			//トランザクションの開始
			$dataSource = $this->getDataSource();
			$dataSource->begin($this);

			if($this->save($_params)){
				if($_params['STATUS']==1){

					if($request->Group_Request($_userid,$_grpid)){
						$dataSource->commit($this);
						return $_params['STATUS'];
					}else{
						return false;
					}
				}else{
					$dataSource->commit($this);
					return $_params['STATUS'];
				}
			}
			else{
				$dataSource->rollback($this);
				return false;
			}
		}else{
			if($status['Join']['STATUS']==1){
				if(!$request->Delete_Request($_userid, $_grpid)){
					return false;
				}else{
					$this->delete($status['Join']['JIN_ID']);
					return 3;
				}
			}else{
				App::import('Model','Timeline');
				$timeline = new Timeline;
				App::import('Model','Watch');
				$watch = new Watch;

				$result = $timeline->find('all',array('fields'=>array('Timeline.TML_ID'),'conditions'=>array('Timeline.ACT_ID'=>array(3,5),'Timeline.VAL_ID'=>$_grpid)));
				foreach($result as $key => $val){
					$res = $watch->find('first',array('fields'=>array('Watch.WCH_ID'),'conditions'=>array('Watch.TML_ID'=>$val['Timeline']['TML_ID'],'Watch.USR_ID'=>$_userid)));
					if($res!=null){
						$watch->delete($res['Watch']['WCH_ID']);
					}
				}
				$this->delete($status['Join']['JIN_ID']);
				return 3;
			}
		}
		return false;
	}
	function Dlete_All($userid){
		$conditions = array('Join.USR_ID'=>$userid);

		$this->deleteAll($conditions,false,false);

	}

}